import { R as RONIN } from '../codegen-BiMWrHg1.js';
import 'ronin';
import '../index-zz7DDVIX.js';
import 'node:async_hooks';

type ShortText = string;
type LongText = string;
type Number = number;
type Blob = RONIN.Blob;
type Token = string;
type Toggle = boolean;
type RichText = string;
type Time = Date;
type RoninRecord<T> = Required<T> & RONIN.RoninRecord;
type RoninRecords<T> = T[] & {
    moreBefore?: string;
    moreAfter?: string;
};
type ExtractRecordKeys<T extends Record<string, any>> = {
    [K in keyof T]: T[K]['_record'] extends true ? (K extends string ? K : never) : never;
}[keyof T];
interface SchemaRecord<T extends Record<string, any>, TSchema = RoninRecord<T>, TReturn = T> {
    getter: RONIN.IGetterSingular<TSchema, TReturn, never, never, undefined, RONIN.EnrichProvidedIncluding<ExtractRecordKeys<Required<T>>>>;
    dropper: RONIN.IDropper<TSchema, TReturn, never, undefined>;
    counter: RONIN.ICounter<TSchema, never, undefined>;
    setter: RONIN.ISetter<TSchema, TReturn, never>;
    creator: RONIN.ICreator<TSchema, TReturn, never>;
    base: T;
    _record: true;
}
interface SchemaRecords<T extends SchemaRecord<T>, TSchema = RoninRecord<T['base']>, TReturn = RoninRecords<T['base']>> {
    getter: RONIN.IGetterPlural<TSchema, TReturn, never, never, undefined, RONIN.EnrichProvidedIncluding<ExtractRecordKeys<Required<T['base']>>>>;
    dropper: RONIN.IDropper<TSchema, TReturn, never, undefined>;
    counter: RONIN.ICounter<TSchema, never, undefined>;
    setter: RONIN.ISetter<TSchema, TReturn, never>;
    creator: RONIN.ICreator<TSchema, TReturn, never>;
}

export type { Blob, LongText, Number, RichText, RoninRecord, RoninRecords, SchemaRecord, SchemaRecords, ShortText, Time, Toggle, Token };
